/*
 * Copyright (c) 1992, 1993, 1996
 *	Berkeley Software Design, Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Berkeley Software
 *	Design, Inc.
 *
 * THIS SOFTWARE IS PROVIDED BY Berkeley Software Design, Inc. ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL Berkeley Software Design, Inc. BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	BSDI int2f.c,v 2.2 1996/04/08 19:32:53 bostic Exp
 */

#include "doscmd.h"

void
int2f(struct sigcontext *sc)
{               
	int c;

	switch(GET8H(sc->sc_eax)) {
	case 0x00:
	case 0x01:
	case 0x02:
	case 0x03:
	case 0x04:
		debug (D_FILE_OPS, "Called printer function 0x%02x", GET8H(sc->sc_eax));
		sc->sc_eflags |= PSL_C;
		SET8L(sc->sc_eax, FUNC_NUM_IVALID);
		break;
	case 0x12:
		switch (GET8L(sc->sc_eax)) {
		case 0x2e:
		    /* XXX - GET/SET ERROR TABLE ADDRESSES */
		    debug (D_HALF, "GET/SET ERROR TABLE %d\n", GET8L(sc->sc_edx));
		    sc->sc_eflags |= PSL_C;
		    break;
		default:
		    unknown_int4(0x2f, 0x12, GET8L(sc->sc_eax), GET8L(sc->sc_edx), sc);
		    break;
    	    	}
		break;
    	case 0x16:
		switch (GET8L(sc->sc_eax)) {
		case 0x80:
			tty_pause();
			SET8L(sc->sc_eax, 0x00);
			break;
		default:
			unknown_int3(0x2f, 0x16, GET8L(sc->sc_eax), sc);
			break;
		}
		break;
	default:
		unknown_int2(0x2f, GET8H(sc->sc_eax), sc);
		break;
	}
}
